<?php

namespace Woodfish\Component\Payment\AliPay;

/**
 * Class MobileExpressGateway
 *
 * @package Omnipay\Alipay
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface authorize(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface completeAuthorize(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface capture(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface refund(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface void(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface createCard(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface updateCard(array $options = array())
 * @method \Woodfish\Component\Payment\Omnipay\Common\Message\ResponseInterface deleteCard(array $options = array())
 */
class MobileExpressGateway extends BaseAbstractGateway
{

    public function getDefaultParameters()
    {
        $params = parent::getDefaultParameters();

        $params['signType'] = 'RSA';

        return $params;
    }


    /**
     * Get gateway display name
     *
     * This can be used by carts to get the display name for each gateway.
     */
    public function getName()
    {
        return 'Alipay Mobile Express';
    }


    public function getPrivateKey()
    {
        return $this->getParameter('private_key');
    }


    public function setPrivateKey($value)
    {
        $this->setParameter('private_key', $value);
    }


    public function purchase(array $parameters = array())
    {
        $this->setService("mobile.securitypay.pay");
        return $this->createRequest('\Woodfish\Component\Payment\AliPay\Message\MobileExpressPurchaseRequest', $parameters);
    }

    function __call($name, $arguments)
    {
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface authorize(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface completeAuthorize(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface capture(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface refund(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface void(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface createCard(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface updateCard(array $options = array())
        // TODO: Implement @method \Omnipay\Common\Message\ResponseInterface deleteCard(array $options = array())
    }
}
